var outputFile = 'news',
    RssBraider = require('rss-braider'),
    fs = require('fs'),
    ejs = require('ejs'),
    read = require('fs').readFileSync,
    join = require('path').join,
    str = read(join(__dirname, '/templates/rss.ejs'), 'utf8'),
    feeds = {};

// Pull feeds from config files: ,
//      feeds.simple_test_feed = require("./config/feed").feed;
// Or define in-line

feeds.simple_test_feed = {
    "feed_name": "feed",
    "default_count": 1,
    "no_cdata_fields": [], // Don't wrap these fields in CDATA tags
    "meta": {
        "title": "News",
        "description": "Combined News Feed",
        'site_url': 'http://pipes.silvrtree.co.uk/news.xml'
    },
    "plugins": ['filter_3_days', 'fix_images', 'fix_scripts'],
    "sources": [{
        "count": 100,
        "feed_url": "http://qz.com/feed/"
    },
               {
        "count": 100,
        "feed_url": "http://feeds2.feedburner.com/businessinsider"
    },
               {
        "count": 100,
        "feed_url": "http://mf.feeds.reuters.com/reuters/UKTopNews"
    }
               ,
               {
        "count": 100,
        "feed_url": "http://mf.feeds.reuters.com/reuters/UKdomesticNews"
    },
               {
        "count": 100,
        "feed_url": "http://hosted2.ap.org/atom/APDEFAULT/cae69a7523db45408eeb2b3a98c0c9c5"
    },
               {
        "count": 100,
        "feed_url": "http://www.cityam.com/feeds/main.xml"
    },
               {
        "count": 100,
        "feed_url": "http://www.londonlovesbusiness.com/navrss?navsectioncode=121"
    },
               {
        "count": 100,
        "feed_url": "http://www.ibtimes.co.uk/rss/uk"
    },
               {
        "count": 100,
        "feed_url": "http://feeds.bbci.co.uk/news/rss.xml?edition=uk"
    },
               {
        "count": 100,
        "feed_url": "http://feeds.bbci.co.uk/news/scotland/rss.xml?edition=uk"
    },
               {
        "count": 100,
        "feed_url": "http://news.google.com/?output=rss"
    },
               {
        "count": 100,
        "feed_url": "http://feeds.feedburner.com/TheAtlantic"
    },
               {
        "count": 100,
        "feed_url": "http://www.telegraph.co.uk/newsfeed/rss/news-uk_news.xml"
    },
               {
        "count": 100,
        "feed_url": "http://www.telegraph.co.uk/news/worldnews/rss"
    },
               {
        "count": 100,
        "feed_url": "http://www.guardian.co.uk/rssfeed/0,,1,00.xml"
    },
               {
        "count": 100,
        "feed_url": "http://www.marketwatch.com/rss/topstories"
    }

               ]
};
var braider_options = {
    feeds: feeds,
    indent: "    ",
    date_sort_order: "desc", // Newest first
    log_level: "warn",
    dedupe_fields: ['link', 'guid'],
    plugins_directories: [__dirname + "/plugins/"]
};
var rss_braider = RssBraider.createClient(braider_options);

// Override logging level (debug, info, warn, err, off)
//rss_braider.logger.level('off');

rss_braider.processFeed('simple_test_feed', 'json', function(err, data) {
    if (err) {
        return console.log(err);
    }

    var j = JSON.parse(data);
    var ejsOutput = ejs.compile(str)(j);

    fs.writeFile(__dirname + "/html/" + outputFile + ".html", ejsOutput, function(err) {

        if (err) {
            return console.log(err);
        }

        console.log("The file was saved!");
    });

    fs.writeFile(__dirname + "/html/" + outputFile + ".json", data, function(err) {
        if (err) {
            return console.log(err);
        }

        console.log("The file was saved!");
    });
});

rss_braider.processFeed('simple_test_feed', 'rss', function(err, data) {
    if (err) {
        return console.log(err);
    }
    fs.writeFile(__dirname + "/html/" + outputFile + ".xml", data, function(err) {
        if (err) {
            return console.log(err);
        }

        console.log("The file was saved!");
    });
});
